<?php
  // Seitentitel einfügen
  $seitentitel = 'Registrierung';
  require_once('header.php');

  require_once('appvars.php');
  require_once('verbvars.php');

  // Mit Datenbank verbinden
  $db = mysqli_connect(DB_HOST, DB_BENUTZER, DB_PASSWORT, DB_NAME);
  mysqli_set_charset($db, "utf8");
  
  if (isset($_POST['submit'])) {
    // Anmeldedaten aus $_POST auslesen
    $nutzername = mysqli_real_escape_string($db, trim($_POST['nutzername']));
    $passwort1 = mysqli_real_escape_string($db, trim($_POST['passwort1']));
    $passwort2 = mysqli_real_escape_string($db, trim($_POST['passwort2']));

    if (!empty($nutzername) && !empty($passwort1) && !empty($passwort2) && ($passwort1 == $passwort2)) {
      // Prüfen, dass dieser Benutzername noch nicht verwendet wird

      $sql = "SELECT * FROM hl_nutzer WHERE nutzername = '$nutzername'";
      $daten = mysqli_query($db, $sql);
      if (mysqli_num_rows($daten) == 0) {
        // Der Benutzername ist eindeutig, Daten können in Datenbank eingefügt werden
        $sql = "INSERT INTO hl_nutzer (nutzername, passwort, anmeldedatum) VALUES ('$nutzername', SHA('$passwort1'), NOW())";
        mysqli_query($db, $sql);

        // Dem Benutzer die erfolgreiche Anmeldung bestätigen
        echo '<p>Ihr Konto wurde erstellt. Sie können sich jetzt einloggen und ihr ' .
          '<a href="profilbearbeiten.php">Profil bearbeiten</a>.</p>';

        mysqli_close($db);
        exit();
      }      else {
        // Benutzername wird bereits verwendet, also Fehlermeldung anzeigen
        echo '<p class="error">Dieser Benutzername ist bereits belegt. ' .
          'Bitte wählen Sie einen anderen.</p>';
        $nutzername = "";
      }
    }
    else {
      echo '<p class="error">Bitte geben Sie alle erforderlichen Daten ein. Vergessen Sie ' .
        'nicht, das Passwort zu wiederholen.</p>';
    }
  }

  mysqli_close($db);
?>

<p>Wählen Sie einen Benutzernamen und ein Passwort, um sich für Hassliebe.net zu registrieren.</p>
<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
  <fieldset>
    <legend>Anmeldedaten</legend>
    <label for="nutzername">Benutzername:</label>
      <input type="text" id="nutzername" name="nutzername" value="<?php if (!empty($nutzername)) echo $nutzername; ?>" /><br />
      <label for="passwort1">Passwort:</label>
      <input type="password" id="passwort1" name="passwort1" /><br />
      <label for="passwort2">Passwort (Wiederholung):</label>
      <input type="password" id="passwort2" name="passwort2" /><br />
    </fieldset>
    <input type="submit" value="Anmelden" name="submit" />
  </form>
  
<?php
  // Fußleiste einfügen
  require_once('footer.php');
?>
