<?php
  // Sitzung starten
  require_once('sitzungsstart.php');

  // Seitentitel einfügen
  $seitentitel = 'Profil ansehen';
  require_once('header.php');

  require_once('appvars.php');
  require_once('verbvars.php');

  // Navigationsmenü anzeigen
  require_once('navmenu.php');
  
  // Vor weiteren Schritten prüfen, ob der Benutzer eingeloggt ist
  if (!isset($_SESSION['id'])) {
    echo '<p class="login">Um auf diese Seite zugreifen, müssen Sie sich <a href="login.php">einloggen</a>.</p>';
    exit();
  }
  
  // Mit Datenbank verbinen
  $db = mysqli_connect(DB_HOST, DB_BENUTZER, DB_PASSWORT, DB_NAME);
  mysqli_set_charset($db, "utf8");
  

  // Profildaten aus Datenbank abrufen
  if (!isset($_GET['id'])) {
    $sql = "SELECT nutzername, vorname, nachname, geschlecht, geburtstag, stadt, bild FROM hl_nutzer WHERE id = '" . $_SESSION['id'] . "'";
  }
  else {
    $sql = "SELECT nutzername, vorname, nachname, geschlecht, geburtstag, stadt, bild FROM hl_nutzer WHERE id = '" . $_GET['id'] . "'";
  }
  $daten = mysqli_query($db, $sql);

  if (mysqli_num_rows($daten) == 1) {
    // Benutzerzeile gefunden, also Benutzerdaten anzeigen
    $zeile = mysqli_fetch_array($daten);
    echo '<table>';
    if (!empty($zeile['nutzername'])) {
      echo '<tr><td class="label">Benutzername:</td><td>' . $zeile['nutzername'] . '</td></tr>';
    }
    if (!empty($zeile['vorname'])) {
      echo '<tr><td class="label">Vorname:</td><td>' . $zeile['vorname'] . '</td></tr>';
    }
    if (!empty($zeile['nachname'])) {
      echo '<tr><td class="label">Nachname:</td><td>' . $zeile['nachname'] . '</td></tr>';
    }
    if (!empty($zeile['geschlecht'])) {
      echo '<tr><td class="label">Geschlecht:</td><td>';
      if ($zeile['geschlecht'] == 'M') {
        echo 'Männlich';
      }
      else if ($zeile['geschlecht'] == 'W') {
        echo 'Weiblich';
      }
      else {
        echo '?';
      }
      echo '</td></tr>';
    }
    if (!empty($zeile['geburtstag'])) {
        if (!isset($_GET['id']) || ($_SESSION['id'] == $_GET['id'])) {
        // Dem Benutzer selbst den Geburtstag anzeigen
        echo '<tr><td class="label">Geburtstag:</td><td>' . $zeile['geburtstag'] . '</td></tr>';
      }
      else {
        // Allen anderen nur das Geburtsjahr anzeigen
        list($jahr, $monat, $tag) = explode('-', $zeile['geburtstag']);
        echo '<tr><td class="label">Geburtstag:</td><td>' . $jahr . '</td></tr>';
      }
    }
    if (!empty($zeile['stadt'])) {
      echo '<tr><td class="label">Wohnort:</td><td>' . $zeile['stadt'] . '</td></tr>';
    }
    if (!empty($zeile['bild'])) {
      echo '<tr><td class="label">Bild:</td><td><img src="' . HL_IMAGESPFAD . $zeile['bild'] .
        '" alt="Profilbild" /></td></tr>';
    }
    echo '</table>';
    if (!isset($_GET['id']) || ($_SESSION['id'] == $_GET['id'])) {
      echo '<p>Möchten Sie Ihr <a href="profilbearbeiten.php">Profil bearbeiten</a>?</p>';
    }
  } // Ende der Prüfung, auf eine Ergebniszeile
  else {
    echo '<p class="fehler">Es gab ein Problem beim Zugriff auf Ihr Profil.</p>';
  }

  mysqli_close($db);
?>
  
<?php
  // Fußleiste einfügen
  require_once('footer.php');
?>
