<?php
// Enable error reporting
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

// Sitzung starten
require_once('sitzungsstart.php');

// Seitentitel einfügen
$seitentitel = 'Profil bearbeiten';
require_once('header.php');

require_once('appvars.php');
require_once('verbvars.php');

// Navigationsmenü anzeigen
require_once('navmenu.php');

// Vor weiteren Schritten prüfen, ob der Benutzer eingeloggt ist
if (!isset($_SESSION['id'])) {
    echo '<p class="login">Um auf diese Seite zugreifen, müssen Sie sich <a href="login.php">einloggen</a>.</p>';
    exit();
}

// Mit Datenbank verbinden
$db = mysqli_connect(DB_HOST, DB_BENUTZER, DB_PASSWORT, DB_NAME);
if (!$db) {
    die("Connection failed: " . mysqli_connect_error());
}
mysqli_set_charset($db, "utf8");

echo '<p>Damit das Formular erfolgreich ausgeführt wird, müssen immer alle Daten ausgefüllt sein.</p>';

if (isset($_POST['submit'])) {
    // Profildaten aus $_POST auslesen
    $vorname = mysqli_real_escape_string($db, trim($_POST['vorname']));
    $nachname = mysqli_real_escape_string($db, trim($_POST['nachname']));
    $geschlecht = mysqli_real_escape_string($db, trim($_POST['geschlecht']));
    $geburtstag = mysqli_real_escape_string($db, trim($_POST['geburtstag']));
    $stadt = mysqli_real_escape_string($db, trim($_POST['stadt']));
    $altes_bild = mysqli_real_escape_string($db, trim($_POST['altes_bild']));
    $neues_bild = mysqli_real_escape_string($db, trim($_FILES['neues_bild']['name']));
    $neues_bild_typ = $_FILES['neues_bild']['type'];
    $neues_bild_groesse = $_FILES['neues_bild']['size'];
    
    // Initialize image size variables
    $neues_bild_breite = 0;
    $neues_bild_hoehe = 0;

    // Check if a new image is uploaded
    if (!empty($_FILES['neues_bild']['tmp_name'])) {
        list($neues_bild_breite, $neues_bild_hoehe) = getimagesize($_FILES['neues_bild']['tmp_name']);
    }
    
    $fehler = false;

    // Falls erforderlich hochgeladene Bilddatei prüfen und verschieben
    if (!empty($neues_bild)) {
        if ((($neues_bild_typ == 'image/gif') || ($neues_bild_typ == 'image/jpeg') || ($neues_bild_typ == 'image/pjpeg') ||
            ($neues_bild_typ == 'image/png')) && ($neues_bild_groesse > 0) && ($neues_bild_groesse <= HL_MAXDATEIGROESSE) &&
            ($neues_bild_breite <= HL_MAXBILDBREITE) && ($neues_bild_hoehe <= HL_MAXBILDHOEHE)) {
            if ($_FILES['neues_bild']['error'] == 0) {
                // Die hochgeladene Datei in das Bildverzeichnis verschieben
                $ziel = HL_IMAGESPFAD . basename($neues_bild);
                if (move_uploaded_file($_FILES['neues_bild']['tmp_name'], $ziel)) {
                    // Neu Bilddatei wurde erfolgreich hochgeladen, also alte löschen
                    if (!empty($altes_bild) && ($altes_bild != $neues_bild)) {
                        @unlink(HL_IMAGESPFAD . $altes_bild);
                    }
                } else {
                    // Neues Bild konnte nicht verschoben werden, also temporäre Datei löschen und Fehler-Flag setzen
                    @unlink($_FILES['neues_bild']['tmp_name']);
                    $fehler = true;
                    echo '<p class="fehler">Beim Upload der Bilddatei trat ein Fehler auf</p>';
                }
            }
        } else {
            // Die neue Bilddatei ist nicht gültig, also temporäre Datei löschen und Fehler-Flag setzen
            @unlink($_FILES['neues_bild']['tmp_name']);
            $fehler = true;
            echo '<p class="fehler">Die Datei muss eine GIF-, JPEG- oder PNG-Datei sein und darf' .
                ' nicht größer als ' . (HL_MAXDATEIGROESSE / 1024) . ' KB oder ' . HL_MAXBILDBREITE . 'x' . HL_MAXBILDHOEHE . ' Pixel sein.</p>';
        }
    } 

    // Die Profildaten in der Datenbank aktualisieren
    if (!$fehler) {
        if (!empty($vorname) && !empty($nachname) && !empty($geschlecht) && !empty($geburtstag) && !empty($stadt)) {
            // Bildspalte nur setzen, wenn es ein neues Bild gibt
            if (!empty($neues_bild)) {
                $sql = "UPDATE hl_nutzer SET vorname = '$vorname', nachname = '$nachname', geschlecht = '$geschlecht', " .
                    " geburtstag = '$geburtstag', stadt = '$stadt', bild = '$neues_bild' WHERE id = '" . $_SESSION['id'] . "'";
            } else {
                $sql = "UPDATE hl_nutzer SET vorname = '$vorname', nachname = '$nachname', geschlecht = '$geschlecht', " .
                    " geburtstag = '$geburtstag', stadt = '$stadt' WHERE id = '" . $_SESSION['id'] . "'";
            }
            if (mysqli_query($db, $sql)) {
                // Aktualisierung des Profils bestätigen
                echo '<p>Ihr Profil wurde erfolgreich aktualisiert. Möchten Sie sich das aktualisierte <a href="profilansehen.php">Profil ansehen</a>?</p>';
            } else {
                echo '<p class="fehler">Fehler beim Aktualisieren des Profils: ' . mysqli_error($db) . '</p>';
            }

            mysqli_close($db);
            exit();
        } else {
            echo '<p class="fehler">Sie müssen sämtliche Profildaten ausfüllen (das Bild ist optional).</p>';
        }
    }
} else {
    // Profil aus der Datenbank abrufen
    $sql = "SELECT vorname, nachname, geschlecht, geburtstag, stadt, bild FROM hl_nutzer WHERE id = '" . $_SESSION['id'] . "'";
    $daten = mysqli_query($db, $sql);
    $zeile = mysqli_fetch_array($daten);

    if ($zeile != NULL) {
        $vorname = $zeile['vorname'];
        $nachname = $zeile['nachname'];
        $geschlecht = $zeile['geschlecht'];
        $geburtstag = $zeile['geburtstag'];
        $stadt = $zeile['stadt'];
        $altes_bild = $zeile['bild'];
    } else {
        echo '<p class="fehler">Auf Ihr Profil konnte nicht zugegriffen werden.</p>';
    }
}

mysqli_close($db);
?>

<form enctype="multipart/form-data" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
    <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo HL_MAXDATEIGROESSE; ?>" />
    <fieldset>
        <legend>Persönliche Daten</legend>
        <label for="vorname">Vorname:</label>
        <input type="text" id="vorname" name="vorname" value="<?php if (!empty($vorname)) echo $vorname; ?>" /><br />
        <label for="nachname">Nachname:</label>
        <input type="text" id="nachname" name="nachname" value="<?php if (!empty($nachname)) echo $nachname; ?>" /><br />
        <label for="geschlecht">Geschlecht:</label>
        <select id="geschlecht" name="geschlecht">
            <option value="M" <?php if (!empty($geschlecht) && $geschlecht == 'M') echo 'selected = "selected"'; ?>>Männlich</option>
            <option value="W" <?php if (!empty($geschlecht) && $geschlecht == 'W') echo 'selected = "selected"'; ?>>Weiblich</option>
        </select><br />
        <label for="geburtstag">Geburtstag:</label>
        <input type="text" id="geburtstag" name="geburtstag" value="<?php if (!empty($geburtstag)) echo $geburtstag; else echo 'JJJJ-MM-TT'; ?>" /><br />
        <label for="stadt">Wohnort:</label>
        <input type="text" id="stadt" name="stadt" value="<?php if (!empty($stadt)) echo $stadt; ?>" /><br />
        <input type="hidden" name="altes_bild" value="<?php if (!empty($altes_bild)) echo $altes_bild; ?>" />
        <label for="neues_bild">Bild:</label>
        <input type="file" id="neues_bild" name="neues_bild" />
        <?php if (!empty($altes_bild)) {
            echo '<img class="profil" src="' . HL_IMAGESPFAD . $altes_bild . '" alt="Profilbild" />';
        } ?>
    </fieldset>
    <input type="submit" value="Profil speichern" name="submit" />
</form>

<?php
// Fußleiste einfügen
require_once('footer.php');
?>
